﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Infragistics.Controls.Editors;
using Infragistics.Windows;
using Infragistics.Controls.Editors.Primitives;

namespace MultiComboInGrid
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void XamMultiColumnComboEditor_Loaded(object sender, RoutedEventArgs e)
        {
            (sender as XamMultiColumnComboEditor).IsDropDownOpen = true;
            SpecializedTextBox txt = Utilities.GetDescendantFromType(sender as DependencyObject, typeof(SpecializedTextBox), false) as SpecializedTextBox;
            txt.SelectAll();
            txt.Focus();

        }

        private void MultiCombo_EditEnd(object sender, Infragistics.Windows.Editors.Events.EditModeEndingEventArgs e)
        {
            XamMultiColumnComboEditor editor = Utilities.GetDescendantFromType(sender as DependencyObject, typeof(XamMultiColumnComboEditor), false) as XamMultiColumnComboEditor;
            editor.IsDropDownOpen = false;
        }
    }

    public class VM
    {
        public VM()
        {
            Random r = new Random();
            Invoices = new ObservableCollection<Invoice>();

            for (int i = 0; i < 10; i++)
            {
                Invoices.Add(new Invoice { InvoiceCode = "IVC" + r.Next(1000), Description = "Invoice description " + i, Price = r.Next(10000, 20000) });
            }

            Data = new ObservableCollection<Data>();

            for (int i = 0; i < 10; i++)
            {
                Data.Add(new Data { ID = i, Name = "Item " + i, Invoice = Invoices[r.Next(Invoices.Count)].InvoiceCode });
            }
        }

        public ObservableCollection<Data> Data { get; set; }
        public ObservableCollection<Invoice> Invoices { get; set; }
    }

    public class InvoiceToStringCodeConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (value is string && parameter is VM)
            {
                VM vm = parameter as VM;

                var res = vm.Invoices.Where(i => i.InvoiceCode == value.ToString()).FirstOrDefault();

                if (res != null)
                    return res;
            }

            return Binding.DoNothing;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (value is Invoice)
            {
                return (value as Invoice).InvoiceCode;
            }
            return Binding.DoNothing;
        }
    }

    public class InvCodeToDescriptionConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (value is string && parameter is VM)
            {
                 VM vm = parameter as VM;

                var res = vm.Invoices.Where(i => i.InvoiceCode == value.ToString()).FirstOrDefault();

                if (res != null)
                    return res.Description;
            }
            return Binding.DoNothing;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }

    public class Data
    {
        public int ID { get; set; }
        public string Name { get; set; }
        public string Invoice { get; set; }
    }

    public class Invoice
    {
        public string InvoiceCode { get; set; }
        public string Description { get; set; }
        public decimal Price { get; set; }
    }
}
